﻿
// SPEAK! 1.0 - 25.01.16
// inspired by 
// http://www.andlil.com/
// https://labs.ig.com/rest-trading-api-guide
// http://blog.teamtreehouse.com/getting-started-speech-synthesis-api

// Globals variables
var urlRoot = "https://demo-api.ig.com/gateway/deal";
var apiKey;
var accountId = null;
var account_token = null;
var client_token = null;
var lsEndpoint = null;
var lsClient;

var timer_id;
var interval_centaine = 5;
var voice_count = 0;
var minute;

// CAC, DAX, DOW
var liste_epic = "IX.D.DAX.IMF.IP,IX.D.CAC.IMF.IP,IX.D.DOW.IFE.IP";

require.config({
    paths: {
        "moment": "assets/js/moment.min"
    },
    config: {
        moment: {
            noGlobal: true
        }
    }
});

require(["LightstreamerClient","Subscription","moment"],
  function(LightstreamerClient,Subscription,moment) {

moment.locale('fr', {
    weekdays : ["Dimanche", "Lundi", "Mardi", "Mercredi", "Jeudi", "Vendredi", "Samedi"]
});

moment.locale('fr');

////////////////////////////////////////
function connectToLightstreamer() {

      console.log("Connecting to Lighstreamer: " + lsEndpoint);

      lsClient = new LightstreamerClient(lsEndpoint);
      lsClient.connectionDetails.setUser(accountId);

      var password = "";
      if (client_token) {
         password = "CST-" + client_token;
      }
      if (client_token && account_token) {
         password = password + "|";
      }
      if (account_token) {
         password = password + "XST-" + account_token;
      }

      lsClient.connectionDetails.setPassword(password);

      lsClient.addListener({
         onListenStart: function () {
            console.log('Lightstreamer client - start listening');
         },
         onStatusChange: function (status) {
            console.log('Lightstreamer connection status:' + status);
         }
      });

      // Connect
      lsClient.connect();
}


//////////////////////////////////////////
function login(mode) {

  var identifier,password;

  //DEMO
  urlRoot = "https://demo-api.ig.com/gateway/deal";

  identifier = $("#username").val();
  password   = $("#password").val();
  apiKey     = $("#apikey").val();
 

   if (apiKey=="" || identifier=="" || password=="") {
       return false;
   }

   //
   password = encryptedPassword(password,apiKey);

   //
   var req = new Request();
   req.method = "POST";
   req.url = urlRoot + "/session";
   req.headers = {
      "Content-Type": "application/json; charset=UTF-8",
      "Accept": "application/json; charset=UTF-8",
      "X-IG-API-KEY": apiKey,
      "Version": "2"
   };
   var bodyParams = {};
   bodyParams["identifier"] = identifier;
   bodyParams["password"] = password;
   bodyParams["encryptedPassword"] = true;
   req.body = JSON.stringify(bodyParams);

   // 
   try {
      $.ajax({
         type: req.method,
         url: req.url,
         data: req.body,
         headers: req.headers,
         async: false,
         mimeType: req.binary ? 'text/plain; charset=x-user-defined' : null,
         success: function (response, status, data) {
            // Successful login 
            account_token = data.getResponseHeader("X-SECURITY-TOKEN");
            client_token = data.getResponseHeader("CST");
            accountId = response.currentAccountId;
            lsEndpoint = response.lightstreamerEndpoint;

            $(".account").html('(Compte démo : '+accountId+")");

            // remember me
            if ($('#remember').is(':checked')) {
              var o = {i:identifier,k:apiKey};
              localStorage.setItem('speak!', JSON.stringify(o));
            }
            else
            {
              // or forget me
              localStorage.removeItem('speak!');
            }

         },
         error: function (response, status, error) {
            // Login failed
            $("#login-pane .alert").removeClass("hide");
            $("#login-pane .alert").show();
         }
      });
   } catch (e) {
      //console.log(e);
      handleException(e);
   }

   // true if loginsuccessfull
   return (accountId!=undefined);
}


////////////////////////////////////////////////
function init_markets() {

   var req = new Request();
   req.method = "GET";
   req.url = urlRoot + "/markets?epics="+liste_epic;
   req.headers = {
      "X-IG-API-KEY": apiKey,
      "X-SECURITY-TOKEN": account_token,
      "CST": client_token,
      "Content-Type": "application/json; charset=UTF-8",
      "Accept": "application/json; charset=UTF-8"
   };
   req.body = "";

   //
   try {
      $.ajax({
         type: req.method,
         url: req.url,
         data: req.body,
         headers: req.headers,
         async: false,
         mimeType: req.binary ? 'text/plain; charset=x-user-defined' : null,
         error: function (response, status, error) {
            handleHTTPError(response);
         },
         success: function (response, status, data) {

            $('#search_results_list tbody').empty();
            var epicsItems = [];

            $(response.marketDetails).each(function (index) {

              var marketsData = response.marketDetails[index].instrument;
              var epic = marketsData.epic;
              var canSubscribe = marketsData.streamingPricesAvailable;
              var tidyEpic = epic.replace(/\./g, "_");
              var expiry = marketsData.expiry.replace(/ /g, "");
              var linkId = "searchResult_" + tidyEpic;

              $('#search_results_list tbody:last')
                  .append($('<tr>')
                     .append(
                        $('<td>')
                           .append($('<div>')
                              .attr("id", linkId)
                              .append(marketsData.name)
                            )
                      )
                     .append(
                        $('<td class="prix">')
                        .append("<a id='search_" + tidyEpic + "_BID' class='btn btn-danger' href='#' role='button'></a>")
                      )
                     .append(
                        $('<td class="prix">')
                        .append("<a id='search_" + tidyEpic + "_OFFER' class='btn btn-info' href='#' role='button'></a>")
                      )
                     .append(
                        $('<td class="prix">')
                        .append("<div id='search_" + tidyEpic + "_UPDATE_TIME'></div>")
                      )
                     .append(
                        $('<td class="prix">')
                        .append("<div id='search_" + tidyEpic+"_CHANGE'></div>")
                      )
                  );

              if (canSubscribe) {
                  var epicsItem = "L1:" + marketsData.epic;
                  epicsItems.push(epicsItem);
              }

              return index < 39;
            });

            // Subscribe to prices
            if (epicsItems.length > 0) {

                  var subscription = new Subscription(
                     "MERGE",
                     epicsItems,
                     [
                        "BID",
                        "OFFER",
                        "UPDATE_TIME",
                        "CHANGE"
                     ]
                  );

                  subscription.setRequestedSnapshot("yes");

                  //
                  subscription.addListener({
                     onSubscription: function () {
                        console.log('subscribed PRICES');
                     },
                     onSubscriptionError: function (code, message) {
                        console.log('subscription failure: ' + code + " message: " + message);
                     },
                     onItemUpdate: function (updateInfo) {

                        // Lightstreamer published some data
                        var epic = updateInfo.getItemName().split(":")[1];
                        var tidyEpic = epic.replace(/\./g, "_");

                        updateInfo.forEachField(function (fieldName, fieldPos, value) {

                            var fieldId = "search_" + tidyEpic + "_" + fieldName;
                            var cell = $("#" + fieldId);

                            if (fieldName=='UPDATE_TIME' && value!=null) {
                                var clock = moment(value,"HH:mm:ss").add(1, 'hours');
                                value = clock.format("HH:mm:ss");
                            }

                            if (fieldName && cell) {
                                cell.html($('<div>').addClass("tickCell").append(value));
                            } 

                        });
                     }
                  });

                  //
                  lsClient.subscribe(subscription);
            }
         }
      });
   } catch (e) {
      handleException(e);
   }
}


//////////////////////////////////////////
function showTradingPane() {
  $('#login-pane').hide();
  $('#container').removeClass("container-hidden").addClass("container");
}

////////// ACTIONS BIND ////////////
$('#loginButton').click(function () {

    if (login("DEMO")) {

      showTradingPane();
      $('.divstart').hide();

      // ====================================
      if ('speechSynthesis' in window) {
       // console.log('Your browser <strong>supports</strong> speech synthesis.');
      } else {
        console.log('Désolé, votre navigateur ne parle pas !');
        $('.panel-heading').html('Désolé, votre navigateur ne parle pas !');
        $('.panel-body').remove();
        return false;
      }

      // indice
      $('#indiceselect').change(function() {
        var lang = $('#voiceselect').val();
        if (lang.indexOf("français")>0) {
          speak("Vous écoutez le "+$(this).children(':selected').text());
        }
        else
        {
          speak("You listen to the "+$(this).children(':selected').text());
        }
      });

      // fréquence des prix
      $('#repeatselect').change(function() {
        // stop actual timer
        clearInterval(timer_id);
        // update timer
        var freq = $(this).val()*1000;
        timer_id = setInterval(function () {
                    speak();
                  }, freq);
      });

      // shut up
      $('#stop').click(function() {
        $('.divstop').hide();
        $('.divstart').show();
        clearInterval(timer_id);
      });

      // speak !
      $('#start').click(function() {
        $('.divstart').hide();
        $('.divstop').show();
        timer_id = setInterval(function () {
                      speak();
                      }, 1000);
      })

      //
      connectToLightstreamer();
      //
      init_markets();
      //
      loadVoices();

      // Chrome loads voices asynchronously.
      window.speechSynthesis.onvoiceschanged = function(e) {
        loadVoices();
      };

      // SPEAKING LOOP
      timer_id = setInterval(function () {
                    speak();
                  }, 5000);

    };
   
    return false;
 
});

//////////////:
function loadVoices() {

  var voices = speechSynthesis.getVoices();
  
  // fill the combo
  voices.forEach(function(voice, i) {

    // don't know why, sometimes the list is filled twice, so : 
    var exists = false;
    $('#voiceselect option').each(function(){
        if (this.value == voice.name) {
            exists = true;
            return false;
        }
    });

    if ((exists) || (i>=16)) {return false;}

    // default = français
    if (voice.name == 'Google français')
    {
      $('#voiceselect').append($('<option>', {
        value: voice.name,
        text: CapFirstLetter(voice.name.replace("Google ", "")),
        selected : true
      }));
    }
    else
    {
      $('#voiceselect').append($('<option>', {
        value: voice.name,
        text: CapFirstLetter(voice.name.replace("Google ", ""))
      }));
    }

  }); // each

}

//////////////:
function speak(txt) {

  var msg = new SpeechSynthesisUtterance();
  msg.volume  = 1.0;
  msg.rate    = 1.0;
  msg.pitch   = 1.0;

  var mylang = $('#voiceselect').val();
  msg.voice = speechSynthesis.getVoices().filter(function(voice) { return voice.name == mylang; })[0];
  
  // get price
  var epic = $("#indiceselect").val();
  var bid = $("#search_"+epic+"_BID .tickCell").html();
  var ask = $("#search_"+epic+"_OFFER .tickCell").html();

  // get hour
  var actual_hour = $("#search_"+epic+"_UPDATE_TIME .tickCell").html();
  actual_hour = actual_hour.substr(0, 5);
  var actual_minute = actual_hour.substr(3, 4);

  // HEURE : toutes les x minutes
  var modulo = $("#hourselect").val();
  if ((actual_minute!=minute) && (actual_minute % modulo == 0))
  {
    msg.text = "Il est "+actual_hour;
    if (mylang.indexOf('English')>0) {
      //msg.text = "It is "+actual_hour;
    }
    msg.rate = 1.1; //lecture de l'heure + rapide (pour faire style c'est pas la même voix...)
    // l'heure toujours en français
    msg.voice = speechSynthesis.getVoices().filter(function(voice) { return voice.name == 'Google français'; })[0];
    // DIRE L'HEURE
    window.speechSynthesis.speak(msg); 
    minute = actual_minute;
  }

  // PRIX
  if (bid==undefined) {return false;}

  var integer_price = Math.floor((1*bid+1*ask)/2);
  var dizaine   = Math.floor((integer_price-100*Math.floor(integer_price/100)));
  var centaine  = Math.floor((integer_price-1000*Math.floor(integer_price/1000)));

  if (!!txt) {
    msg.text = txt;
  }
  else
  {
    msg.text = dizaine;
  }
  
  // centaines...
  voice_count++;
  if (voice_count == interval_centaine) {
    voice_count=0;
    // dire les centaines ?
    if ($('#tell100').is(':checked')) {
        msg.text = centaine;

        // version anglophone ;)
        if (mylang.indexOf('English')>0) {
          msg.text = centaine.toString().substr(0, 1)+" "+centaine.toString().substr(1, 2)
        }
    }
  }

  // ======= speak ========
  // reinit (à cause de l'heure en Français)
  msg.rate = 1.0;
  msg.voice = speechSynthesis.getVoices().filter(function(voice) { return voice.name == mylang; })[0];

  // filtres sur prix ?
  var bornemin = $('#seuil-inf').val();
  var bornemax = $('#seuil-sup').val();
  var condition1 = (bornemin!='') && (integer_price<=bornemin);
  var condition2 = (bornemax!='') && (integer_price>=bornemax);

  // reset status
  $('.alerte.min').removeClass('has-success').removeClass('has-error');
  $('.alerte.max').removeClass('has-success').removeClass('has-error');

  if (condition1) {$('.alerte.min').addClass('has-success');}
    else {$('.alerte.min').addClass('has-error');}
  if (condition2) {$('.alerte.max').addClass('has-success');}
    else {$('.alerte.max').addClass('has-error');}

  // si vide, pas de filtre
  if (bornemin=='') {
    $('.alerte.min').removeClass('has-success').removeClass('has-error');
  }
  if (bornemax=='') {
    $('.alerte.max').removeClass('has-success').removeClass('has-error');
  }
  
  // feinte quand aucun filtre présent (je sais c'est moche)
  if ((bornemin=='') && (bornemax=='')) {condition1=true;condition2=true;}

  //
  if (condition1 || condition2) {
    window.speechSynthesis.speak(msg);

    // visual speak signal pour le fun
    $(".panel-heading .glyphicon" ).fadeOut(500,function() {
          $(".panel-heading .glyphicon" ).fadeIn(200,function() {
          });
    });
  }

} // function

////////////////////////////
function CapFirstLetter(string) {
    return string.charAt(0).toUpperCase() + string.slice(1);
}

////////////////////////////
function handleHTTPError(response) {
  console.log("handleHTTPError",response);

  $("#alertStatusCode").text(response.status);

  try {
      var responseJson = jQuery.parseJSON(response.responseText);
      $("#alertErrorCode").text(responseJson.errorCode);
  } catch (e) {
      $("#alertErrorCode").text(response.responseText);
  }

  $("#errorAlert").removeClass("hide");
  $("#errorAlert").show();
}

////////////////////////////
function handleException(exception) {
  console.log("handleException",exception);

  $("#response_data").text(exception);
  $("#alertStatusCode").text("unknown");

  try {
      var responseJson = jQuery.parseJSON(response.responseText);
      $("#alertErrorCode").text(responseJson.errorCode);
  } catch (e) {
      $("#alertErrorCode").text(exception);
  }

  $("#errorAlert").removeClass("hide");
  $("#errorAlert").show();

}

////////////////////////////
function Request(o) {
   this.headers = {"Content-Type": "application/json; charset=UTF-8", "Accept": "application/json; charset=UTF-8"};
   this.body = "";
   this.method = "";
   this.url = "";
}

////////////////////////////
function handleError(title,message) {
  console.log("error",title,message);
  $("#alertStatusCode").text(title);
  $("#alertErrorCode").text(message);
  $("#errorAlert").removeClass("hide");
  $("#errorAlert").show();
}

///////////////////////////
function encryptedPassword(password,apikey) {

    var key = encryptionKey(apikey);
    var asn, tree;
    var rsa = new pidCrypt.RSA();
    var decodedKey = pidCryptUtil.decodeBase64(key.encryptionKey);

    asn = pidCrypt.ASN1.decode(pidCryptUtil.toByteArray(decodedKey));
    tree = asn.toHexTree();
    rsa.setPublicKeyFromASN(tree);

    return pidCryptUtil.encodeBase64(pidCryptUtil.convertFromHex(rsa.encrypt(password += '|' + key.timeStamp)))

}

///////////////////////////
function encryptionKey(apiKey) {

    // 
    var req = new Request();
    req.method = "GET";
    req.url = urlRoot + "/session/encryptionKey";
    req.headers = {
        "X-IG-API-KEY": apiKey,
        "Content-Type": "application/json; charset=UTF-8",
        "Accept": "application/json; charset=UTF-8"
    };
    req.body = "";

    // 
    var key;
    try {
        $.ajax({
            type: req.method,
            url: req.url,
            data: req.body,
            headers: req.headers,
            async: false,
            mimeType: req.binary ? 'text/plain; charset=x-user-defined' : null,
            error: function (response, status, error) {
                handleHTTPError(response);
            },
            success: function (response, status, data) {
                key = response;
            }
        });
    } catch (e) {
        handleException(e);
    }

    return key;

}

// ==== START ====
// connection datas already there ?
var o = localStorage.getItem('speak!');
if (!!o) {
  var cnx = JSON.parse(o);
  $('#login-pane #username').val(cnx.i);
  $('#login-pane #apikey').val(cnx.k);

  $('#remember').prop('checked', true);
}


});






